diff -uNrd ircd-hybrid-6.3.1.dist/src/s_conf.c ircd-hybrid-6.3.1/src/s_conf.c
--- ircd-hybrid-6.3.1.dist/src/s_conf.c	Sun Feb 17 00:58:13 2002
+++ ircd-hybrid-6.3.1/src/s_conf.c	Tue Apr 29 22:27:38 2003
@@ -19,7 +19,7 @@
  *
  *  (C) 1988 University of Oulu,Computing Center and Jarkko Oikarinen"
  *
- *  $Id: s_conf.c,v 1.236 2002/02/17 05:58:13 lusky Exp $
+ *  $Id: s_conf.c,v 1.237 2002/04/28 08:13:02 androsyn Exp $
  */
 #include "m_commands.h"
 #include "s_conf.h"
@@ -85,9 +85,11 @@
 static void clear_special_conf(struct ConfItem **);
 static struct ConfItem* find_tkline(const char*, const char*, unsigned long);
 static void expire_temp_klines(struct ConfItem **tklines);
+static void expire_temp_dlines(struct ConfItem **tdlines);
 
 struct ConfItem *temporary_klines = NULL;
 struct ConfItem *temporary_ip_klines = NULL;
+struct ConfItem *temporary_dlines = NULL;
 
 static  char *set_conf_flags(struct ConfItem *,char *);
 static  int  oper_privs_from_string(int,char *);
@@ -139,9 +141,6 @@
 /* conf qline link list root */
 aQlineItem         *q_conf = ((aQlineItem *)NULL);
 
-/* conf uline link list root */
-struct ConfItem        *u_conf = ((struct ConfItem *)NULL);
-
 /* keep track of .include files to hash in */
 struct ConfItem        *include_list = ((struct ConfItem *)NULL);
 
@@ -155,7 +154,7 @@
 {
   struct ConfItem* aconf = (struct ConfItem*) vptr;
   aconf->dns_pending = 0;
-  if (reply->status == adns_s_ok)
+  if (reply && (reply->status == adns_s_ok))
     aconf->ipnum.s_addr = reply->rrs.addr->addr.inet.sin_addr.s_addr;
   MyFree(reply);
 }
@@ -376,8 +375,6 @@
 
   if (flags & CONF_XLINE)
     this_conf = x_conf;
-  else if (flags & CONF_ULINE)
-    this_conf = u_conf;
   else return;
 
   for (aconf = this_conf; aconf; aconf = aconf->next)
@@ -486,6 +483,12 @@
             }
 #endif        /* GLINES */
 
+         if(IsMustResolve(aconf) && IsDigit(cptr->host[strlen(cptr->host)-1]))
+            {
+              sendto_one(cptr, ":%s NOTICE %s :*** Your IP must resolve to use this server", me.name, cptr->name);
+              return ( -1 );
+            }
+
           if(IsConfDoIdentd(aconf))
             SetNeedId(cptr);
 
@@ -1393,8 +1396,6 @@
 
   if(mask & CONF_XLINE)
     this_conf = x_conf;
-  else if(mask & CONF_ULINE)
-    this_conf = u_conf;
   else
     return((struct ConfItem *)NULL);
 
@@ -1840,6 +1841,9 @@
         case '^':        /* is exempt from k/g lines */
           aconf->flags |= CONF_FLAGS_E_LINED;
           break;
+        case '/':        /* clients host must resolve */
+          aconf->flags |= CONF_FLAGS_RESOLVE;
+          break;
         case '&':        /* obsolete flag was "can run a bot" */
           break;
         case '>':        /* can exceed max connects */
@@ -1853,6 +1857,11 @@
           aconf->flags |= CONF_FLAGS_IDLE_LINED;
           break;
 #endif
+        case '{':        /* exempt from clone checks */
+#ifdef CHECK_CLONE
+          aconf->flags |= CONF_FLAGS_CLONE_EXEMPT;
+#endif
+          break;
         default:
           return tmp;
         }
@@ -2096,11 +2105,6 @@
           aconf->status = CONF_QUARANTINED_NICK;
           break;
 
-        case 'U': /* Uphost, ie. host where client reading */
-        case 'u': /* this should connect.                  */
-          aconf->status = CONF_ULINE;
-          break;
-
         case 'X': /* rejected gecos */
         case 'x': 
           aconf->status = CONF_XLINE;
@@ -2172,6 +2176,19 @@
                 break;
               aconf->port = oper_privs_from_string(aconf->port,tmp);
             }
+#ifdef NEG_PORT
+          else if(aconf->status & CONF_CONNECT_SERVER)
+            {
+              if ((tmp = getfield(NULL)) == NULL)
+                break;
+              aconf->port = atoi(tmp);
+              if (aconf->port && (aconf->port < 0))
+                {
+                  aconf->flags &= ~CONF_FLAGS_ALLOW_AUTO_CONN;
+                  aconf->port = abs(aconf->port);
+                }
+            }
+#endif
           else
             {
               if ((tmp = getfield(NULL)) == NULL)
@@ -2201,7 +2218,7 @@
               if(classToFind && (ClassPtr(aconf) == class0))
                 {
                   sendto_realops(
-                           "Warning *** Defaulting to class 0 for class %d",
+                           "Warning: Defaulting to class 0 for class %d",
                          classToFind);
                 }
             }
@@ -2503,16 +2520,6 @@
           aconf->next = x_conf;
           x_conf = aconf;
         }
-      else if (aconf->status & CONF_ULINE)
-        {
-          dontadd = 1;
-          MyFree(aconf->user);
-          aconf->user = (char *)NULL;
-          aconf->name = aconf->host;
-          aconf->host = (char *)NULL;
-          aconf->next = u_conf;
-          u_conf = aconf;
-        }
       else if (aconf->status & CONF_QUARANTINED_NICK)
         {
           dontadd = 1;
@@ -2695,7 +2702,11 @@
 
   if (aconf && !IsConfElined(aconf))
     return 0;
-  return 1;
+
+  if((aconf = find_tdline(ntohl((unsigned long)addr.s_addr))))
+      return 0;
+  else
+      return 1;
 }
 
 /*
@@ -2742,10 +2753,12 @@
       else
         *tklines = cur_p->next;
 
+#ifdef TKLINE_EXPIRE_NOTICE
       /* Alert opers that a TKline expired - Hwy */
       sendto_realops("Temporary K-line for [%s@%s] expired",
                      (cur_p->user) ? cur_p->user : "*",
                      (cur_p->host) ? cur_p->host : "*");
+#endif
       free_conf(cur_p);
     }
     else
@@ -2753,6 +2766,39 @@
   }
 }
 
+/* expire_temp_dlines()
+ *
+ * inputs	- pointer to dline list
+ * output	-
+ * side effects - dlines that have "expired" are cleared
+ */
+static void expire_temp_dlines(struct ConfItem **tdlines)
+{
+    struct ConfItem *ptr;
+    struct ConfItem *next_ptr;
+    struct ConfItem *last_ptr = NULL;
+
+    for(ptr = *tdlines; ptr; ptr = next_ptr)
+    {
+	next_ptr = ptr->next;
+
+	if(ptr->hold <= CurrentTime)
+	{
+	    if(last_ptr != NULL)
+		last_ptr->next = ptr->next;
+	    else
+		*tdlines = ptr->next;
+
+#ifdef TDLINE_EXPIRE_NOTICE
+	    sendto_realops("Temporary D-line for [%s] expired", ptr->host);
+#endif
+	    free_conf(ptr);
+	}
+	else
+	    last_ptr = ptr;
+    }
+}
+    
 /*
  * find_tkline
  *
@@ -2792,6 +2838,27 @@
   return (NULL);
 }
 
+/* find_tdline()
+ *
+ * inputs	- hostname
+ * outputs	-
+ * side effects - returns matching ConfItem or NULL
+ */
+struct ConfItem *find_tdline(unsigned long ip)
+{
+    struct ConfItem *ptr;
+    
+    expire_temp_dlines(&temporary_dlines);
+
+    for(ptr = temporary_dlines; ptr; ptr = ptr->next)
+    {
+	if(ptr->ip && ((ip & ptr->ip_mask) == ptr->ip))
+	    return ptr;
+    }
+
+    return NULL;
+}
+
 /*
  * find_is_klined()
  *
@@ -2820,6 +2887,8 @@
   found_aconf = find_matching_mtrie_conf(host, name, ntohl(ip));
   if(found_aconf && (found_aconf->status & (CONF_ELINE|CONF_DLINE|CONF_KILL)))
     return(found_aconf);
+  else if((found_aconf = find_tdline(ntohl(ip))))
+      return found_aconf;
   else
     return NULL;
 }
@@ -2848,6 +2917,31 @@
   else
     return NULL;
 }
+
+struct ConfItem *
+is_tklined(const char *host,const char *name, unsigned long ip)
+{
+  struct ConfItem *found_aconf;
+
+  if( (found_aconf = find_tkline(host, name, ip)) )
+    return(found_aconf);
+
+  return NULL;
+}
+
+struct ConfItem *
+is_pklined(const char *host,const char *name, unsigned long ip)
+{
+  struct ConfItem *found_aconf;
+
+  found_aconf = find_matching_mtrie_conf(host, name, ip);
+
+  if(found_aconf && (found_aconf->status & CONF_KILL))
+    return(found_aconf);
+  else
+    return NULL;
+}
+
   
 /* add_temp_kline
  *
@@ -2873,6 +2967,18 @@
     }
 }
 
+/* add_temp_dline()
+ *
+ * inputs	- pointer to ConfItem
+ * outputs	-
+ * side effects - ConfItem is added to dline list
+ */
+void add_temp_dline(struct ConfItem *aconf)
+{
+    aconf->next = temporary_dlines;
+    temporary_dlines = aconf;
+}
+
 /* flush_temp_klines
  *
  * inputs        - NONE
@@ -2925,6 +3031,28 @@
 
 }
 
+/* report_temp_dlines
+ *
+ * input	- client to report to
+ * output	-
+ * side effects - client is shown temp dline list
+ */
+void report_temp_dlines(struct Client *sptr)
+{
+    struct ConfItem *ptr;
+    char *name, *host, *pass, *user;
+    int port;
+
+    expire_temp_dlines(&temporary_dlines);
+    for(ptr = temporary_dlines; ptr; ptr = ptr->next)
+    {
+	get_printable_conf(ptr, &name, &host, &pass, &user, &port);
+
+        sendto_one(sptr, form_str(RPL_STATSDLINE), me.name,
+		   sptr->name, 'd', host, pass);
+    }
+}
+
 /* show_temp_klines
  *
  * inputs	- aClient pointer, client to report to
@@ -3010,6 +3138,10 @@
         int_privs |= CONF_OPER_DIE;         /* allow die */
       else if(*privs == 'd')
         int_privs &= ~CONF_OPER_DIE;        /* disallow die */
+      else if(*privs == 'A')
+        int_privs |= CONF_OPER_ADMIN;       /* is marked as an admin */
+      else if(*privs == 'a')
+        int_privs &= ~CONF_OPER_ADMIN;      /* not an admin */
       privs++;
     }
   return(int_privs);
@@ -3105,6 +3237,16 @@
   else
     *privs_ptr++ = 'd';
 
+  if (port & CONF_OPER_ADMIN)
+    {
+      if(cptr)
+        SetOperAdmin(cptr);
+      *privs_ptr++ = 'A';
+    }
+  else
+    *privs_ptr++ = 'a';
+
+
   *privs_ptr = '\0';
 
   return(privs_out);
@@ -3152,6 +3294,14 @@
         int_flags |= FLAGS_EXTERNAL;
       else if(*flags == 'z')
         int_flags |= FLAGS_OPERWALL;
+      else if(*flags == 'l')
+       int_flags |= FLAGS_LOCOPS;
+      else if(*flags == 'u')
+        int_flags |= FLAGS_UNAUTH;
+      else if(*flags == 'j')
+        int_flags |= FLAGS_JUPE;
+      else if(*flags == 'a')
+        int_flags |= FLAGS_ADMIN;
       flags++;
     }
 
@@ -3169,7 +3319,7 @@
 
 char *oper_flags_as_string(int flags)
 {
-  static char flags_out[16];
+  static char flags_out[18];
   char *flags_ptr;
 
   flags_ptr = flags_out;
@@ -3201,6 +3351,14 @@
     *flags_ptr++ = 'x';
   if(flags & FLAGS_OPERWALL)
     *flags_ptr++ = 'z';
+  if(flags & FLAGS_LOCOPS)
+    *flags_ptr++ = 'l';
+  if(flags & FLAGS_UNAUTH)
+    *flags_ptr++ = 'u';
+  if(flags & FLAGS_JUPE)
+    *flags_ptr++ = 'j';
+  if(flags & FLAGS_ADMIN)
+    *flags_ptr++ = 'a';
   *flags_ptr = '\0';
 
   return(flags_out);
@@ -3413,7 +3571,14 @@
                          host,
                          pass);
                 }
-              else
+              else if((aconf = find_tdline(ip)))
+	      {
+		  get_printable_conf(aconf, &name, &host, &pass, &user, &port);
+		  sendto_one(sptr,
+			     ":%s NOTICE %s :Temp D-line host [%s] pass [%s]",
+			     me.name, parv[0], host, pass);
+	      }
+	      else
                 sendto_one(sptr, ":%s NOTICE %s :No aconf found",
                          me.name, parv[0]);
             }
@@ -3648,7 +3813,6 @@
 
     zap_Dlines();
     clear_special_conf(&x_conf);
-    clear_special_conf(&u_conf);
     clear_q_lines();
     mark_listeners_closing();
 }
@@ -3681,121 +3845,6 @@
             free_conf(tmp2);
         }
     }
-}
-
-/*
- * write_kline_or_dline_to_conf_and_notice_opers
- *
- * inputs       - kline or dline type flag
- *              - client pointer to report to
- *              - server pointer to relay onto
- *              - user name of target
- *              - host name of target
- *              - reason for target
- *              - current tiny date string
- * output       - -1 if error on write, 0 if ok
- * side effects - This function takes care of
- *                finding right kline or dline conf file, writing
- *                the right lines to this file, 
- *                notifying the oper that their kline/dline is in place
- *                notifying the opers on the server about the k/d line
- *                forwarding the kline onto the next U lined server
- *                
- * Bugs         - This function is still doing too much
- */
-
-void write_kline_or_dline_to_conf_and_notice_opers(
-                                                   KlineType type,
-                                                   aClient *sptr,
-                                                   aClient *rcptr,
-                                                   char *user,
-                                                   char *host,
-                                                   char *reason,
-                                                   char *current_date)
-  {
-  char buffer[1024];
-  int out;
-  const char *filename;         /* filename to use for kline */
-
-  filename = get_conf_name(type);
-
-#ifdef SLAVE_SERVERS
-  if(!IsServer(sptr))
-#endif
-    {
-      if(type == DLINE_TYPE)
-        {
-          sendto_realops("%s added D-Line for [%s] [%s]",
-                         sptr->name, host, reason);
-          sendto_one(sptr, ":%s NOTICE %s :Added D-Line [%s] to %s",
-                     me.name, sptr->name, host, filename);
-        }
-      else
-        {
-          sendto_realops("%s added K-Line for [%s@%s] [%s]",
-                         sptr->name, user, host, reason);
-          sendto_one(sptr, ":%s NOTICE %s :Added K-Line [%s@%s] to %s",
-                     me.name, sptr->name, user, host, filename);
-        }
-    }
-
-  if ((out = open(filename, O_RDWR|O_APPEND|O_CREAT,0644))==-1)
-    {
-      sendto_realops("Problem opening %s ", filename);
-      return;
-    }
-
-  fchmod(out, 0660);
-
-#ifdef SLAVE_SERVERS
-  if(IsServer(sptr))
-    {
-      if((type==KLINE_TYPE) && rcptr)
-        ircsprintf(buffer, "#%s!%s@%s from %s K'd: %s@%s:%s\n",
-                   rcptr->name, rcptr->username, rcptr->host,
-                   sptr->name,
-                   user, host, reason);
-    }
-  else
-#endif
-    {
-      if(type==KLINE_TYPE)
-        ircsprintf(buffer, "#%s!%s@%s K'd: %s@%s:%s\n",
-                   sptr->name, sptr->username, sptr->host,
-                   user, host, reason);
-      else
-        ircsprintf(buffer, "#%s!%s@%s D'd: %s:%s\n",
-                   sptr->name, sptr->username, sptr->host,
-                   host, reason);
-    }
-  
-  if (safe_write(sptr,filename,out,buffer))
-    return;
-
-  if(type==KLINE_TYPE)
-    ircsprintf(buffer, "K:%s:%s (%s):%s\n",
-               host,
-               reason,
-               current_date,
-               user);
-  else
-    ircsprintf(buffer, "D:%s:%s (%s)\n",
-               host,
-               reason,
-               current_date);
-
-
-  if (safe_write(sptr,filename,out,buffer))
-    return;
-      
-  close(out);
-
-  if(type==KLINE_TYPE)
-    log(L_TRACE, "%s added K-Line for [%s@%s] [%s]",
-        sptr->name, user, host, reason);
-  else
-    log(L_TRACE, "%s added D-Line for [%s] [%s]",
-           sptr->name, host, reason);
 }
 
 /*
diff -uNrd ircd-hybrid-6.3.1.dist/src/s_debug.c ircd-hybrid-6.3.1/src/s_debug.c
--- ircd-hybrid-6.3.1.dist/src/s_debug.c	Sun Dec 16 00:49:19 2001
+++ ircd-hybrid-6.3.1/src/s_debug.c	Sat Apr 19 21:06:45 2003
@@ -178,23 +178,23 @@
 
 
   sendto_one(cptr,
-             ":%s %d %s :CPU Secs %d:%d User %d:%d System %d:%d",
+             ":%s %d %s :CPU Secs %ld:%d User %ld:%d System %ld:%d",
              me.name, RPL_STATSDEBUG, nick, secs/60, secs%60,
              rus.ru_utime.tv_sec/60, rus.ru_utime.tv_sec%60,
              rus.ru_stime.tv_sec/60, rus.ru_stime.tv_sec%60);
-  sendto_one(cptr, ":%s %d %s :RSS %ld ShMem %d Data %d Stack %d",
+  sendto_one(cptr, ":%s %d %s :RSS %ld ShMem %ld Data %ld Stack %ld",
              me.name, RPL_STATSDEBUG, nick, rus.ru_maxrss,
              rus.ru_ixrss / rup, rus.ru_idrss / rup,
              rus.ru_isrss / rup);
-  sendto_one(cptr, ":%s %d %s :Swaps %d Reclaims %d Faults %d",
+  sendto_one(cptr, ":%s %d %s :Swaps %ld Reclaims %ld Faults %ld",
              me.name, RPL_STATSDEBUG, nick, rus.ru_nswap,
              rus.ru_minflt, rus.ru_majflt);
-  sendto_one(cptr, ":%s %d %s :Block in %d out %d",
+  sendto_one(cptr, ":%s %d %s :Block in %ld out %ld",
              me.name, RPL_STATSDEBUG, nick, rus.ru_inblock,
              rus.ru_oublock);
-  sendto_one(cptr, ":%s %d %s :Msg Rcv %d Send %d",
+  sendto_one(cptr, ":%s %d %s :Msg Rcv %ld Send %ld",
              me.name, RPL_STATSDEBUG, nick, rus.ru_msgrcv, rus.ru_msgsnd);
-  sendto_one(cptr, ":%s %d %s :Signals %d Context Vol. %d Invol %d",
+  sendto_one(cptr, ":%s %d %s :Signals %ld Context Vol. %ld Invol %ld",
              me.name, RPL_STATSDEBUG, nick, rus.ru_nsignals,
              rus.ru_nvcsw, rus.ru_nivcsw);
 
diff -uNrd ircd-hybrid-6.3.1.dist/src/s_misc.c ircd-hybrid-6.3.1/src/s_misc.c
--- ircd-hybrid-6.3.1.dist/src/s_misc.c	Sun Feb 17 13:16:03 2002
+++ ircd-hybrid-6.3.1/src/s_misc.c	Fri May  2 11:39:23 2003
@@ -43,22 +43,12 @@
 #include <sys/param.h>
 #include <time.h>
 #include <unistd.h>
-
-
-static char* months[] = {
-  "January",   "February", "March",   "April",
-  "May",       "June",     "July",    "August",
-  "September", "October",  "November","December"
-};
-
-static char* weekdays[] = {
-  "Sunday",   "Monday", "Tuesday", "Wednesday",
-  "Thursday", "Friday", "Saturday"
-};
+#include <stdlib.h>
 
 char* date(time_t clockval) 
 {
   static        char        buf[80], plus;
+  static        char        tbuf[80];
   struct        tm *lt, *gm;
   struct        tm        gmbuf;
   int        minswest;
@@ -82,10 +72,8 @@
   if (minswest < 0)
     minswest = -minswest;
   
-  ircsprintf(buf, "%s %s %d %d -- %t:%t:%t %c%t:%t",
-          weekdays[lt->tm_wday], months[lt->tm_mon],lt->tm_mday,
-          lt->tm_year + 1900, lt->tm_hour, lt->tm_min, lt->tm_sec,
-          plus, minswest/60, minswest%60);
+  strftime(tbuf, 80, "%A %e %B %Y -- %T", lt);
+  ircsprintf(buf, "%s %c%t:%t", tbuf, plus, minswest/60, minswest%60);
 
   return buf;
 }
@@ -206,11 +194,11 @@
 /* Make ISUPPORT string */
 char *make_isupport()
 {
-  static char tisupport[200];
+  static char tisupport[300];
 
   ircsprintf(tisupport, "WALLCHOPS PREFIX=(ov)@+ CHANTYPES=#& MAXCHANNELS=%d "
                         "MAXBANS=%d NICKLEN=%d TOPICLEN=%d KICKLEN=%d "
-                        "NETWORK=%s "
+                        "NETWORK=%s MAP CHARSET=rfc1459 CASEMAPPING=rfc1459 "
 #ifdef CHANMODE_E
                         "CHANMODES=be,k,l,imnpst EXCEPTS"
 #else
@@ -225,4 +213,118 @@
   return tisupport;
 }
 
+/* Handles an operator's time parameter, numbers are defaulted to
+** minutes, d, h, w are accepted and are used to specify lengthier time
+** periods.  This allows opers to do /quote kline 1d ...
+** instead of /quote kline 1440 ..., something easier to remember and
+** far clearer.
+**
+** Return value:  a time in minutes or 0.  0 symbolizes failure as per
+** the original kline implementation.  If the user explicitely sets 0
+** as a time, it will be changed to 1 as per Hybrid 6's m_kline.c.
+*/
+int oper_time(char *timestr)
+{
+  int minutes = 0;
+  char digitbuf[11]; /* XXX define */
+  int i = 0;
+  char *timeptr;
+  int bufval;
+
+  /* Should never happen but... */
+  if (timestr == NULL)
+    return 0;
+
+  /* If there is not a digit here, it's a failure */
+  if (!IsDigit(*timestr))
+    return 0;
+
+  for (timeptr = timestr; *timeptr != '\0'; timeptr++)
+  {
+    if (i == 10)
+    {
+      /* Not the best thing to do, but to avoid overflows... */
+      break;
+    }
+    if (IsDigit(*timeptr))
+    {
+      digitbuf[i] = *timeptr;
+      i++;
+    }
+    else
+    {
+      switch (*timeptr)
+      {
+        /* I personally don't recommend week long klines in Hybrid 6...
+        ** but it's here if wanted
+        */
+        case 'w':
+        case 'W':
+          {
+            digitbuf[i] = '\0';
+            bufval = atoi(digitbuf);
+            i = 0;
+            digitbuf[0] = '\0';
+            minutes += (bufval * 10080);
+            break;
+          }
+        case 'd':
+        case 'D':
+          {
+            digitbuf[i] = '\0';
+            bufval = atoi(digitbuf);
+            i = 0;
+            digitbuf[0] = '\0';
+            minutes += (bufval * 1440);
+            break;
+          }
+        case 'h':
+        case 'H':
+          {
+            digitbuf[i] = '\0';
+            bufval = atoi(digitbuf);
+            i = 0;
+            digitbuf[0] = '\0';
+            minutes += (bufval * 60);
+            break;
+          }
+        case 'm':
+        case 'M':
+          {
+            digitbuf[i] = '\0';
+            minutes += atoi(digitbuf);
+            i = 0;
+            digitbuf[0] = '\0';
+            break;
+          }
+        case '.':
+        case '@':
+        case ':': /* For H7 ports */
+          {
+            /* If any of these characters are found, this is LIKELY a 
+            ** an address or a user@ something.  It is considered a failure
+            ** and MUST be rejected
+            */
+            return 0;
+            /* NOT REACHED */
+            break;
+          }
+        default:
+          break;
+      }
+    }
+  }
+
+  /* Ok, anything left will default to minutes */
+  digitbuf[i] = '\0';
+  minutes += atoi(digitbuf);
+
+  /* This check is from the old implementation, to prevent /quote kline 0 ...
+  ** from working.  The 0 will be turned into 1 minute.
+  */
+  if (minutes == 0)
+    minutes = 1;
+
+  return minutes;
+}
 
diff -uNrd ircd-hybrid-6.3.1.dist/src/s_serv.c ircd-hybrid-6.3.1/src/s_serv.c
--- ircd-hybrid-6.3.1.dist/src/s_serv.c	Mon Apr 15 18:38:22 2002
+++ ircd-hybrid-6.3.1/src/s_serv.c	Fri May  2 11:41:05 2003
@@ -74,6 +74,11 @@
   { "EX",       CAP_EX },
   { "CHW",      CAP_CHW },
   { "KNOCK",    CAP_KNOCK },
+#ifdef HUB
+  { "KLN",      CAP_KLN },
+  { "UNKLN",    CAP_UNKLN },
+#endif
+  { "ENCAP",    CAP_ENCAP },
   { 0,   0 }
 };
 
@@ -276,6 +281,11 @@
         next = aconf->hold;
     }
 
+#ifndef NEG_PORT
+  /* The negative ports kludge allows you to specify ports for every
+  ** server, just not autoconnect to each one.  This message can get QUITE
+  ** annoying when using this feature, so just hide it -Hwy
+  */
   if (0 == GlobalSetOptions.autoconn)
     {
       /*
@@ -292,6 +302,7 @@
       Debug((DEBUG_NOTICE,"Next connection check : %s", myctime(next)));
       return next;
     }
+#endif
 
   if (connecting)
     {
@@ -310,6 +321,8 @@
         }
       if (!(con_conf->flags & CONF_FLAGS_ALLOW_AUTO_CONN))
         {
+#ifndef NEG_PORT
+/* Same as above...hide these when using NEG_PORT */
 #ifdef HIDE_SERVERS_IPS
           sendto_realops("Connection to %s not activated, autoconn is off.",
 			 con_conf->name);
@@ -321,6 +334,7 @@
           sendto_realops("WARNING AUTOCONN on %s[%s] is disabled",
 			 con_conf->name, con_conf->host);
 #endif
+#endif /* NEG_PORT */
         }
       else
         {
@@ -501,6 +515,12 @@
                  acptr->hopcount + 1, acptr->tsinfo, ubuf,
                  acptr->username, acptr->host,
                  acptr->user->server, acptr->info);
+#ifdef PROPAGATE_AWAY
+#ifdef BURST_AWAY
+      if (acptr->user->away)
+        sendto_one(cptr, ":%s AWAY :%s", acptr->name, acptr->user->away);
+#endif
+#endif
     }
 }
 
@@ -521,7 +541,10 @@
   int tl;
 
   t = msgbuf;
-  tl = ircsprintf(msgbuf, "TS ");
+  if (IsServer(acptr) && (acptr->serv != NULL) && (acptr->serv->tsversion > 0))
+    tl = ircsprintf(msgbuf, "TS:%d ", acptr->serv->tsversion);
+  else
+    tl = ircsprintf(msgbuf, "TS ");
   t += tl;
 
   /* Short circuit if no caps -- send back TS and that's it. */
@@ -942,11 +965,24 @@
 
   for(cptr2 = serv_cptr_list; cptr2; cptr2 = cptr2->next_server_client)
     {
-      ++j;
-      sendto_one(cptr, ":%s %d %s :%s (%s!%s@%s) Idle: %d",
+      time_t days, hours, minutes, seconds;
+
+      seconds = CurrentTime;
+      seconds -= cptr2->firsttime;
+
+      days = seconds / 86400;
+      seconds %= 86400;
+      hours = seconds / 3600;
+      seconds %= 3600;
+      minutes = seconds / 60;
+      seconds %= 60;
+      sendto_one(cptr, ":%s %d %s :%s (%s!%s@%s) Idle: %d Connected: %ld day%s %ld:%ld:%ld",
                  me.name, RPL_STATSDEBUG, cptr->name, cptr2->name,
                  (cptr2->serv->by[0] ? cptr2->serv->by : "Remote."), 
-                 "*", "*", CurrentTime - cptr2->lasttime);
+                 "*", "*", CurrentTime - cptr2->lasttime,
+		 days, (days == 1) ? "" : "s", hours, minutes, seconds);
+
+      j++;
 
       /*
        * NOTE: moving the username and host to the client struct
